;
;			4 GRAYSCALE LIBRARY
;		       	   by Andreas Ess
;
;			     FOR USGARD
;	      by Andreas Ess, Austin Butler, Sam Davies and Mel Tsai
;
;Special thanks go to Robert Taylor!!!
;
;With this lib, you can easily program 4 grayscale under Usgard. All routines
;are explained below.
;
;REQUIREMENTS:
;3K or 1K in RAM for the pages.
;22 bytes in TEXT_MEM2(from TEXT_MEM2+145 - TEXT_MEM2+167)
;
GRAY4LIB = 4	;LIBRARY ID

;NAME:		GR4_INSTALL
;FUNCTION: 	initializes 4 grayshade graffa
;OUTPUT:	Carry = 1 if not enough mem, AF, BC, DE, HL destroyed
GR4_INSTALL = 0

;NAME:		GR4_REMOVE
;FUNCTION:	removes the grayscales again
;OUTPUT:	AF, BC, DE, HL destroyed
GR4_REMOVE = 1

;NAME:		GR4_FLIP
;FUNCTION:	flips the two pages
;OUTPUT:	AF, HL destroyed
GR4_FLIP = 2

;NAME:		GR4_CLEAR
;FUNCTION:	clears the inactive page
;OUTPUT:	BC, DE, HL destroyed
GR4_CLEAR = 3

;NAME:		GR4_SPRITE8
;FUNCTION:	a 8x8 sprite routine, no clipping
;INPUT:		B=x(0-127),C=y(0-63), IX = sprite
;OUPUT:		sprite gets drawn, no register destroyed
GR4_SPRITE8 = 4

;NAME:		GR4_ACTIVE
;FUNCTION:	is grayscale active?
;OUTPUT:	A = 1 -> grayscale active, 0 -> not active
GR4_ACTIVE = 5

;NAME:		GR4_INSTALL_LITE
;FUNCTION: 	initializes 4 grayshade graffa, but needs only 1K, flipping not
;		supported! (Page1Addr) & (Page2Addr) = actual RAM
;OUTPUT:	Carry = 1 if not enough mem, AF, BC, DE, HL destroyed
GR4_INSTALL_LITE = 6

;
;The vars stored in TEXT_MEM2
;
Count		= TEXT_MEM2+149
CurrPage	= TEXT_MEM2+150
PageA		= TEXT_MEM2+151
PageB		= TEXT_MEM2+152
PageC		= TEXT_MEM2+153
PageD		= TEXT_MEM2+154
PageAAddr	= TEXT_MEM2+155
PageBAddr	= TEXT_MEM2+157
PageCAddr	= TEXT_MEM2+159
PageDAddr	= TEXT_MEM2+161
Page1Addr	= TEXT_MEM2+163
Page2Addr	= TEXT_MEM2+165
;(can't access Page1 & Page2)
