;
;			       MOUSE LIBRARY
;		       	      by  Andreas Ess
;
;			 	FOR  USGARD
;	by Andreas Ess, Austin Butler, Sam Davies and Mel Tsai
;
;This library allows you to have a kind of a mouse interface in your program.
;All routines are explained below. In the program, the mouse pointer will be
;activated by holding MORE. After activating, use the arrow keys to move and
;2nd to 'click'.
;
;REQUIREMENTS:
;needs the topmost bytes from TEXT_MEM2(from TEXT_MEM2+160 to TEXT_MEM2+167)
;because it's an interrupt routine.
;
MSELIB = 10

;NAME: 		MSE_INSTALL
;FUNCTION:	Installs the mouse, sets standard mouse bitmap
;OUTPUT:	AF, BC, HL, DE destroyed
MSE_INSTALL = 0

;NAME:		MSE_REMOVE
;FUNCTION:	Removes the mouse
;OUTPUT:	AF, BC, HL, DE destroyed
MSE_REMOVE = 1

;NAME:		MSE_AREA
;FUNCTION:	Checks if mouse pointer is between (B,C) and (H,L)
;INPUT:		BC = upper left corner, HL = lower right corner
;OUTPUT:    	Carry = 1 if pointer between (BC/HL), AF destroyed
MSE_AREA = 2

;NAME:		MSE_AREAC
;FUNCTION:	same as MSE_AREA, but requires a 'click'
;INPUT/OUTPUT:	see MSE_AREA
MSE_AREAC = 3

;NAME:		MSE_SETRANGE
;FUNCTION:	sets the range where the mouse may be
;INPUT:		BC = upper left corner, HL = lower right corner
;OUTPUT:	HL destroyed
MSE_SETRANGE = 4

;NAME:		MSE_KEY
;FUNCTION:	same as OTH_ARROW, but only if mouse not active
;OUTPUT:	A = same as OTH_ARROW(if MORE not pressed)
MSE_KEY = 5

;
;Variables:
;
MouseY = TEXT_MEM2+160		;Mouse Y location
MouseX = TEXT_MEM2+161          ;Mouse X location
MClick = TEXT_MEM2+162		;0 if no click
MouseAct = TEXT_MEM2+163	;0 if not activated

