;
;		    	d e T u r b o  v1.0
;		     for Usgard by Andreas Ess
;
;This is just a little demo TSR to deturbo your calculator
;
#include "usgard.h"
#include "ugapplib.h"

.org 0
.db "deTurbo v1.0 by AE",0
.db UGAPPLIB,0

Start:
	call	CLEARLCD
	ld	hl, VIDEO_MEM
	ld	b, 112
FillLoop:
	ld	(hl), 255
	inc	hl
	djnz	FillLoop

	ld	hl, $0020
	ld	(CURSOR_X), hl

	set	3, (iy+5)
	ld	hl, (PROGRAM_ADDR)	;PROGRAM_ADDR = Title
	call	D_ZM_STR
	res	3, (iy+5)

;Check if TSR is already installed using CHECK_APPEND.
; HL -> code to check(we only check the unmodified one)
; BC -> length of code.
	ld	hl, &TSRRoutine+2 	;(since the second byte changes)
	ld	bc, RoutineEnd-TSRRoutine-2
	LIB_CALL_(UGAPPLIB,CHECK_APPEND)
	jr	z, InstallTSR
	jr	nc, NotAtTheEnd
	jr	nz, RemoveTSR		;TSR already installed?

InstallTSR:
	ld	hl, $0001
	ld	(CURSOR_ROW), hl
	ld	hl, &InstTxt
	call	D_ZT_STR
	ld	b, 100
	jr	Show
Choice:
	call	GET_KEY
	cp	K_EXIT
	ret	z
	cp	K_ENTER
	jr	z, Done
	cp	K_UP
	jr	z, Raise
	cp	K_DOWN
	jr	nz, Choice
Lower:
	dec	b
	jr	Show
Raise:
	inc	b
Show:
	ld	hl, $1001
	ld	(CURSOR_ROW), hl
	ld	h, 0
	ld	l, b
	call	D_HL_DECI
	jr	Choice

Done:
	push	bc
	ld	hl, &TSRRoutine		;use the & operator to add (PROGRAM_ADDR)
	ld	bc, RoutineEnd-TSRRoutine
	LIB_CALL_(UGAPPLIB,APPEND)	;append the TSR code to Usgard!
	pop	bc
	inc	hl
	ld	(hl), b			;Change delay speed
	dec	hl
	call	INT_INSTALL

	ld	hl, &Installed

WriteText:
	ld	de, $0003
	ld	(CURSOR_ROW), de

	call	D_ZT_STR

	call	OTH_PAUSE
	ret
RemoveTSR:
	call	INT_REMOVE

	ld	bc, RoutineEnd-TSRRoutine
	LIB_CALL_(UGAPPLIB,UNAPPEND)

	ld	hl, &Removed
	jr      WriteText

NotAtTheEnd:
	ld	hl, &NotAtEnd
	jr	WriteText


TSRRoutine:
	ld	b, 1
Delay1:
	ld	c, 64
Delay2:
	dec	c
	jr	nz, Delay2
	djnz	Delay1
	ret
RoutineEnd:

Installed:
	;012345678901234567890
 .db	"Activated",0
InstTxt:
 .db	"Set speed:",0
Removed:
 .db	"Removed",0
NotAtEnd:
 .db	"Not at the end!",0

.end
