;Graph 2 Pic is a tiny program that converts the contents of the GRAPH_MEM into a variable
; that Usgard recognizes as a B/W pic.  That is, it has no compression so it draws just about
; instantly, give or take half an instant.
;This program demonstrates the easy to use amazing variable creation and management features
; that are part of Usgard.
;Because this program is dependant on the graph mem not being destroyed, it must be run from
; the RUN menu.  Explore and also the start menu destroy part of the GRAPH_MEM.  So if your
; shell is Explore you can not run this.
;Written by Austin Butler
;@u$+!N prgms
;mail me:  corndog@flash.net

#include "usgard.h"                     ;Usgard header file.
#include "winlib.h"                     ;Windows library header file.
#include "usgdlib.h"                    ;Temporary place for INPST.
.org 0
.db "Graph 2 Pic",0                     ;Same header and things like ZShell.
.db WINLIB,0                            ;Define which libs MUST be present to run.

	ld      de, (PROGRAM_ADDR)      ;(PROGRAM_ADDR) = header.  Load DE with that as title.
R_1:    ld      ix, text                ;The window contents will be from text.  Use R_ lable
	ld      bc, $030B               ; to skip adding (PROGRAM_ADDR) to it.
	ld      hl, $0A21               ;BC is X,Y pos.  B = X/8.  HL is size.  H = X/8
	ld      a, %11                  ;Status byte.  Bit 0 -> show title.  1 -> show contents
	LIB_CALL_(WINLIB,WIN_PSHOW)     ;Call WINLIB library function to Prepare and Show window.

	ld      hl, $0604               ;Load up Cursor Position to place inpst cursor.
	ld      (CURSOR_ROW), hl
	ld      ix, TEXT_MEM            ;IX is destination.
	ld      c, 8                    ;C is string size.
	LIB_CALL_(USGDLIB,INPST)        ;OTH_INPST is like ti-basic INPST.  Saves TONS of mem.
	xor     a                       ;Check if contents of IX is zero.  EXIT pressed or
	cp      (ix)                    ; nothing inputted if 0.
	ret     z                       ;Quit if so.

	ld      hl, TEXT_MEM            ;VAR_GET searches mem for variable with name at HL.
	call    VAR_GET                 ;OTH_INPST put name at TEXT_MEM.  We are checking if
	jr      nc, varexists           ; a variable already exists with name given.
					;HL is set to data location although not needed now.
					;Carry flag set if not found.  Jump with Non-Carry
	ld      hl, TEXT_MEM            ; since it is there.
	ld      a, $0C                  ;VAR_NEW creates a var.  HL = Var name.
	ld      bc, 1026                ;A = var type.  $0C is string variable.
	call    VAR_NEW                 ;BC is size of data area wanted.
	jr      c, nomemory             ;OUTPUTS: HL = pointer to data location.
					;Carry flag set if can't do it.
	xor     a                       ;Set the first byte to zero.
	ld      (hl), a
	inc     hl                      ;Set second byte to $7D.
	ld      (hl), $7D               ;That is the header for a B/W pic.
	inc     hl                      ;Go one more byte to put data in.
	ld      bc, 1024                ;Set BC to 1024 because that is size of GRAPH_MEM.
	push    hl                      ;Put data pointer to DE for ldir.
	pop     de                      ;DE is destination.
	ld      hl, GRAPH_MEM           ;GRAPH_MEM is source.
	ldir                            ;Move it on over.
	ret                             ;Voila!  You have a B/W pic!  Set it as the background.

varexists:
R_2:    ld      ix, exists              ;WIN_ERROR is little error window.
	LIB_CALL_(WINLIB,WIN_ERROR)     ;IX is contents.  R_ label for speed and memory save.
	ret                             ;WIN_ERROR waits for ENTER or EXIT.
nomemory:
R_3:    ld      ix, nomem               ;Another error.  IX is pointer to text.
	LIB_CALL_(WINLIB,WIN_ERROR)
	ret

text:
.db "Enter Picture Name:",0             ;All the text...
nomem:
.db "No Memory!",0
exists:
.db "Variable already",LF,"exists!",0   ;LF is Line Feed for window contents text.  It skips
					; to the next line.  Makes the text look good.
.end                                    ;Windows do have letter wrapping though.

;Happy programming.  Don't hesitate to mail me with questions.
;corndog@flash.net
