;UGstats is a tiny program to check a few variables in Usgard.  It looks at:
;       Who has registered this program.  As if it matters.
;       What shell is being used.
;       What the contrast is set to.
;       Free memory on the TI.
;       If the expander is connected.
;Austin Butler (C) UGStats was programmed for Usgard by Austin of @u$+!N prgms.


#include "usgard.h"                     ;Header file.  No longer ti-85.h
#include "winlib.h"                     ;Windows library header file.
.org 0                                  ;Program start.

.db "Usgard Status V.1.0",0             ;Same ol' header string.
.db WINLIB,0                            ;Libraries that are manditory.
	ld      bc, $0000               ;Setting up window info.  BC = X,Y position.
	ld      hl, $1039               ;HL = X/8,Y size
	ld      de, (PROGRAM_ADDR)      ;PROGRAM_ADDR points to header string for title bar.
R_1:    ld      ix, text                ;IX = window contents.
	ld      a, %11                  ;Status byte.
	LIB_CALL_(WINLIB,WIN_PSHOW)     ;Call the library.  (Name,Function)
R_cl1:  call    regist                  ;Start the program stuff.
R_cl2:  call    shell                   ;R_* is to add PROGRAM_ADDR with string85.exe.
R_cl3:  call    contrast                ;It turns a CALL_ into a call.  Much faster.
R_cl4:  call    memory

loop:                                   ;GET_KEY loop.
	call    GET_KEY                 ;Everything is a call now.  No ROM_CALLS although
	cp      K_EXIT                  ; GET_KEY was already a call...
	ret     z
	cp      K_ENTER
	ret     z
	jr      loop

regist:                                 ;Simply display the text.
	ld      hl, $1948
	ld      (CURSOR_X), hl
R_4:    ld      hl, registered
	call    D_ZM_STR                ;No more ROM_CALL.
	ret

shell:
	ld      hl, $1F48               ;Set Cursor position.
	ld      (CURSOR_X), hl
	ld      hl, USGSHELL            ;USGSHELL points to shell name, as in usgard.h
	call    D_ZM_STR


contrast:
	ld      hl, $2548               ;Set Cursor to text.
	ld      (CURSOR_X), hl
	ld      b, l                    ;Save X position.
R_6:    ld      hl, cont                ;R_* so it doesn't need to add PROGRAM_ADDR to it.
	call    D_ZM_STR
	ld      a, (CONTRAST)           ;Get the contrast number.
	add     a, b                    ;Add that number to X position of text.
	ld      (CURSOR_X), a           ;Save it.
	ld      a, '|'                  ;Display this line on the line to look like little
	call    M_CHARPUT               ; indicator.
	ret

memory: 
	ld      hl, $2B48
	ld      (CURSOR_X), hl
	call    FREEMEM                 ;Returns free mem on calc in HL.
	call    DM_HL_DECI              ;Display HL as a decimal number.
	ret


text:
.db XTAB,6,STAB1,XTAB,10,"By Austin Butler",LF
.db XTAB,50,"@u$+!N prgms",LF,LF
.db GTAB1,"Registered To:",LF
.db GTAB1,"Current Shell:",LF
.db GTAB1,"Contrast:",LF
.db GTAB1,"Free TI Mem:",XTAB,49,"bytes",0
registered:
.db "NO ONE!!!!!!",0
noexpander:
.db "Not Connected",0
haveexp:
.db "Connected",0
cont:
.db "________",0

.end

;Happy programming!  ;-)
