;
;                       USGARD SHELL LIBRARY:
;written 1997 by Andreas Ess
;
;Some functions used by Usgard Shell.
;
;
#include "usgard.h"

.org 0

.db     1
.dw	INPST

INPST:
 ld	hl, $8358
 or	(hl)
 ld	(hl), a

INPST_clear:
 push   ix
 ld     b, 0                    ;I chose B as counter
 set	2, (iy+12)

INPST_key:
 ld	a, ' '
 ld	($800E), a
 call   GET_KEY
 cp     9
 jr     c, INPST_key
 cp     K_EXIT
 jr     z, INPST_Exit1
 cp     K_ENTER
 jr     z, INPST_Exit
 cp     K_ALPHA
 jp     z, &INPST_change
 cp     K_CLEAR
 jr     z, INPST_bclear
 cp     K_DEL
 jr     nz, CheckOther
 call   &INPST_delete
 jr     INPST_key
CheckOther:
 cp     $2F
 jr     nc, INPST_key
 sub    10
 push   af
 ld     a, b
 cp     c
 jr     nz, INPST_checkcase
 pop    af
 jr     INPST_key
INPST_bclear:
INPST_bclear1:
 call   &INPST_delete
 jr	nz, INPST_bclear1
 jr     INPST_key
INPST_Exit:
 ld     (ix), 0
 pop    ix
 jr	INPST_Exitr
INPST_Exit1:
 pop    ix
 ld     (ix), 0
INPST_Exitr:
 res	2, (iy+12)
 ret

INPST_checkcase:
 ld	de, &number
 bit	4, (iy+$12)
 jr	z, INPST_gotcase
 ld	de, &upper
INPST_gotcase:
 pop    af
 ld     l, a
 ld     h, 0
 add    hl, de
 ld     a, (hl)
 or     a
 jr     z, INPST_key
 bit	5, (iy+$12)
 jr	z, SetChar
 cp	' '
 jr	z, SetChar
 add	a, 32
SetChar:
 ld     (ix), a
 inc    ix
 call   TX_CHARPUT
 inc    b
 jr     INPST_key

INPST_delete:
 dec	b
 inc	b
 ret	z
 ld	(ix), 0
 dec	ix
 ld	a, ' '
 call	TX_CHARPUT
; call	TX_CHARPUT
 ld	hl, CURSOR_COL
; dec	(hl)
 dec	(hl)
 dec	(hl)
 dec	b
 ret

INPST_change:
 ld	a, ($8358)
 bit	4, a
 jr	z, SetALPHAB	;Number -> ALPHA
 bit	5, a
 jr	z, SetalphaB	;ALPHA -> alpha
 and	11001111b
 jr	SetCase
SetalphaB:
 set	5, a
 jr	SetCase
SetALPHAB:
 set    4, a
SetCase:
 ld	($8358), a
 jp	&INPST_key

upper:
.db 'X','T','O','J','E',0
.db 0,' ','W','S','N','I'
.db 'D',0,0,'Z','V','R','M'
.db 'H','C',0,0,'Y','U','Q'
.db 'L','G','B',0,0,0,'='
.db 'P','K','F','A'             ;= 37 bytes

;lower:
;.db 'x','t'
;.db 'o','j','e',0,0,' ','w'
;.db 's','n','i','d',0,0,'z'
;.db 'v','r','m','h','c',0,0
;.db 'y','u','q','l','g','b'
;.db 0,0,0,'=','p','k','f','a'   ;= 37 bytes

number:
.db '+','-','*','/','^','!'
.db 0,'~','3','6','9',')','?'
.db 0,0,'.','2','5','8','(','`'
.db 0,0,'0','1','4','7','>',':'
.db 0,0,0,'$',',','%','<','#'   ;= 37 bytes


.end
