;A CShell like shell by Jim Reardon
;eviljim@geocities.com
;feedback is appreciated!

#include        "usgard.h"
#include        "usgdlib.h"

.org    0
.db     "Usgard Super Shell",0

MAXP = 8
MAX_PROGS = TEXT_MEM

	ld      c, 0
StartNew:
	ld      hl, VAT_START-10
	ld      (&VAT_Find+1), hl

Start:
;Draw the screen
	push    bc
	call    CLEARLCD

	ld      hl, VIDEO_MEM
	ld      de, VIDEO_MEM+1
	ld      (hl), 255
	ld      bc, 111
	ldir

	set     3, (iy+05)
	ld      hl, $0001
	ld      (CURSOR_X), hl
	ld      hl, (PROGRAM_ADDR)
	call    D_ZM_STR

	ld      hl, VIDEO_MEM+(8*16)+4
	ld      de, 16
	ld      b, 55
VertLine:
        ld      (hl), $08
	add     hl, de
	djnz    VertLine

;Find available programs:
Start_VAT:
	ld      hl, $0801
	ld      (CURSOR_X), hl

VAT_Find:
	ld      hl, VAT_START-10
	ld      ix, TEXT_MEM2
	ld      c, 0                    ;C = number of programs
VAT_Loop:
	ld      a, (hl)
	cp      $0C
	jr      nz, Skip_NoString
	dec     hl
	ld      e, (hl)
	dec     hl
	ld      d, (hl)
	inc     de
	inc     de
	ld      a, (de)
	and     a
	jr      nz, Skip_NoProg
	inc     de
	ld      a, (de)
	cp      $FA
	jr      c, Skip_NoProg
	dec     hl
	ld      b, (hl)
	dec     hl
	push    ix
VAT_NameLoop:
	ld      a, (hl)
	ld      (ix), a
	inc     ix
	dec     hl
	djnz    VAT_NameLoop
	ld      (ix), 0
	inc     ix
	push    hl
	ld      hl, 2
	add     hl, sp
	call    LD_HL_MHL
	call    D_ZM_STR
	ex      de, hl
	inc     hl
	inc     hl
	ld      a, 40
	ld      (CURSOR_X), a
	call    D_ZM_STR
	ld      a, (CURSOR_Y)
	add     a, 7
	ld      (CURSOR_Y), a
	ld      a, 1
	ld      (CURSOR_X), a
	pop     hl
	pop     de
	inc     c
	ld      a, c
	cp      MAXP
	jr      nc, VAT_Done
VAT_Next:
	ld      de, (VAT_END)
	call    CP_HL_DE
	jr      c, VAT_Done
	jr      VAT_Loop
Skip_NoString:
	dec     hl
	dec     hl
Skip_NoProg:
	dec     hl
	ld      e, (hl)
	ld      d, 0
	inc     e
	or      a
	sbc     hl, de
	jr      VAT_Next
VAT_Done:
	ld      a, c
	cp      MAXP
	jr      z, SetVAT
	ld      hl, VAT_START-10
SetVAT:
	ld      (&VATPos), hl

	dec     a
	ld      (MAX_PROGS), a
	pop     bc
ProgramLoop:
	ld      (iy+8), $8C
	call    &Invert
KeyLoop:
	call    GET_KEY
	and     a
	jr      z, KeyLoop
	call    &Invert
	call    $115
	ld      (iy+8), $84
	cp      K_EXIT
	ret     z
	cp      K_UP
	jr      z, Up
	cp      K_DOWN
	jr      z, Down
	cp      K_MORE
	jr      z, NextPage
	cp      K_ENTER
	jr      z, Exec
        cp      K_SECOND
        jr      z, PowerDown
	ld      hl, CONTRAST
        cp      K_PLUS
	jr      z, ContUp
        cp      K_MINUS
	jr      nz, ProgramLoop

ContDown:
	ld      a, (hl)
	sub     1
	jr      c, ProgramLoop
	ld      (hl), a
	out     (2), a
	jr      ProgramLoop
ContUp:
	ld      a, (hl)
	cp      31
	jr      z, ProgramLoop
	inc     (hl)
	ld      a, (hl)
	out     (2), a
	jr      ProgramLoop

Up:
	ld      a, c
	and     a
	jr      z, NextPage
	dec     c
	jr      ProgramLoop
Down:
	ld      a, c
	ld      hl, MAX_PROGS
	cp      (hl)
	jr      z, NextPage
	inc     c
	jr      ProgramLoop
NextPage:
	ld      c, 0
	ld      hl, (&VATPos)
	ld      (&VAT_Find+1), hl
JumpStart:
	jp      &Start

PowerDown:
        LIB_CALL_(1,1)  ; powerdown routine        
        jr      JumpStart

Exec:
	ld      d, c
	push    bc
	ld      hl, TEXT_MEM2
	ld      bc, 168
	inc     d
	dec     d
	jr      z, Exec_Now
	xor     a
Exec_Srch:
	cpir
	dec     d
	jr      nz, Exec_Srch
Exec_Now:
	call    VAR_EXEC
	im      2
	pop     bc
	jr      JumpStart

Invert:
	push    af
	ld      h, 16*7
	ld      l, c
	call    MUL_HL
	ld      de, VIDEO_MEM+128
	add     hl, de
	ld      b, 112
InvLoop:
	ld      a, (hl)
	cpl
	ld      (hl), a
	inc     hl
	djnz    InvLoop
	pop     af
	ret

VATPos:
	.dw 0

.end
