;A CShell like shell.
#include        "usgard.h"

.org    0
.db     "Usgard Simple+",0
.db	0

MAXP = 8
MAX_PROGS = TEXT_MEM
SAVE_HL = TEXT_MEM+1

StartNew:
Autostart:
	ld	hl, &Setting
	call    VAR_GET
	ret	c
	ld      a, 240
	ld      d, 2
	ld      bc, 10000
SearchStartUp:
	cpir
	dec     d
	jr      nz, SearchStartUp
	ld      a, (hl)
	and     a
	jr      z, NoAutostart
	inc     hl
	ld      b, a
ExecuteEm:
	push    bc
	push    hl
	RCALL_(ExecVar)
	pop     hl
	xor     a
	ld      bc, 9
	cpir
	pop     bc
	djnz    ExecuteEm
NoAutostart:

	xor	a
	ld      (&Folder), a

Start:
	ld      c, 0
	push    bc
	call    CLEARLCD

	ld      hl, VIDEO_MEM
	ld      de, VIDEO_MEM+1
	ld      (hl), 255
	ld      bc, 111
	ldir

	set     3, (iy+05)
	ld      hl, $0001
	ld      (CURSOR_X), hl
	ld      hl, (PROGRAM_ADDR)
	call    D_ZM_STR

	ld      hl, VIDEO_MEM+(8*16)+4
	ld      de, 16
	ld      b, 54
VertLine:
	ld      (hl), $08
        add     hl, de
	djnz    VertLine

;show text of folder next to the title
	ld	hl, $004E
	ld	(CURSOR_X), hl

	ld	a, (&Folder)
	and	a
	jr      z, DisplayTools
	dec	a
	jr      z, DisplayGames
	dec	a
	jr      z, DisplayOther

DisplayTools:
	ld      hl, &ToolsText
	jr      FinishText
DisplayGames:
	ld      hl, &GamesText
	jr      FinishText
DisplayOther:
	ld      hl, &OtherText
FinishText:
	call    D_ZM_STR
	ld      hl, $0801
	ld      (CURSOR_X), hl

;looking into the setting string and find the files
	xor	a
	ld	(MAX_PROGS), a

	ld	a, (&Folder)
	ld	b, a

	ld    	hl, &Setting              ;get setting string
	call    VAR_GET
	jp 	c, &Done
	ld      a, (hl)                 ;Check header byte($FF)
	inc     a
	jp 	nz, &Done

	ld      de, 10                  ;skip background picture
	add     hl, de
	ld      a, b
	and     a
        jr      z, NoFindSection  ;is the section = 0 -> No need to search

	ld      d, a                    ;Find section to show
	ld      a, 240
	ld      bc, 10000
FindSection:
	cpir
	dec     d
	jr      nz, FindSection

NoFindSection
	ld      d, (hl)
	ld      a, d
	and     a
	ret	z
	inc     hl

	ld      b, d
	ld	de, TEXT_MEM2
;Get program description...
GetDescriptionLoop:
	push    bc
	push    hl
	push    de
	call    VAR_GET
	pop     de
	jr      c, Failed
	ld	(SAVE_HL), hl
	pop	hl
	push	hl
	push	hl
CopyName:
	ldi
	ld	a, (hl)
	and	a
	jr	nz, CopyName
	ldi
	pop	hl
	push	hl
	call	D_ZM_STR
	pop	hl
	ld	hl, (SAVE_HL)
	inc	hl
	inc	hl
	inc	hl
	ld	a, 40
	ld	(CURSOR_X), a
	call	D_ZM_STR
	ld	hl, CURSOR_Y
	ld	a, (hl)
	add	a, 6
	ld	(hl), a
	dec	hl
	ld	(hl), 1
	ld	hl, MAX_PROGS
	inc	(hl)
	ld	a, (hl)
	cp	MAXP-1
	jr	nz, Remove
	pop	hl
	pop	bc
	jr	Done

Failed:
Remove:
	pop     hl
	xor     a
	ld      bc, 10
	cpir
	pop     bc
	djnz    GetDescriptionLoop
Done:
	pop     bc

	ld	hl, MAX_PROGS
	ld	a, (hl)
	and	a
	jr	z, WaitFolder
	dec	a
	ld	(hl), a

ProgramLoop:
	ld      (iy+8), $8C
	call    &Invert
KeyLoop:
	halt
	call    GET_KEY
	and     a
	jr      z, KeyLoop
	call    &Invert
	call    $115
	ld      (iy+8), $84
	cp      K_EXIT
	ret     z
	cp      K_UP
        jr      z, CursorUp
	cp      K_DOWN
        jr      z, CursorDown
        cp      K_MORE
        jr      z, TopPage
	cp      K_ENTER
	jr      z, ExecJump
	cp	K_F1
	jr	z, ToolsFolder
	cp	K_F2
	jr	z, GamesFolder
	cp	K_F3
	jr	z, StartUpFolder
	cp      K_F4
	jr      z, StartExplore
	cp      K_F5
	jr      z, StartControl
	cp	K_ALPHA
	call	z, OTH_SHUTDOWN
	jr      ProgramLoop

WaitFolder:
	halt
	call	GET_KEY
	cp	K_F1
	jr	z, ToolsFolder
	cp	K_F2
	jr	z, GamesFolder
	cp	K_F3
	jr	z, StartUpFolder
	cp      K_F4
	jr      z, StartExplore
	cp      K_F5
	jr      z, StartControl
	jr      WaitFolder

CursorUp:
	ld      a, c
	and     a
        jr      z, TopPage
	dec     c
	jr      ProgramLoop
CursorDown:
	ld      a, c
	ld      hl, MAX_PROGS
	cp      (hl)
        jr      z, TopPage
	inc     c
        jr      ProgramLoop
TopPage:
	ld      c, 0
JumpStart:
	jp      &Start

ExecJump:
        jr      Exec

ToolsFolder:
	xor	a
	jr	SetFolder
GamesFolder:
	ld	a, 1
	jr	SetFolder
StartUpFolder:
	ld	a, 2
SetFolder:
	ld	(&Folder), a
	jr	JumpStart

StartControl:
	ld      hl, &Control
	jr      ExecAndDesk
StartExplore:
	ld      hl, &Explore
ExecAndDesk:
	call	&ExecVar
	jr	JumpStart

Exec:
	push    bc
	ld	d, c
	ld      hl, TEXT_MEM2
	ld      bc, 168
	inc     d
	dec     d
	jr      z, Exec_Now
	xor     a
Exec_Srch:
	cpir
	dec     d
	jr      nz, Exec_Srch
Exec_Now:
	call    VAR_EXEC
	im      2
	pop     bc
	ld	hl, USG_BITS
	bit	1, (hl)
	jr      nz, JumpStart
	call	OTH_EXIT

ExecVar:
	call	VAR_EXEC
	ret	c
	ld	hl, USG_BITS
	bit	1, (hl)
	call	z, OTH_EXIT
	ret

Invert:
	push    af
	ld      h, 16*6
	ld      l, c
	call    MUL_HL
	ld      de, VIDEO_MEM+128
	add     hl, de
	ld      b, 112
InvLoop:
	ld      a, (hl)
	cpl
	ld      (hl), a
	inc     hl
	djnz    InvLoop
	pop     af
	ret

ToolsText:
 .db "Tools Folder",0

GamesText:
 .db "Games Folder",0

OtherText:
 .db "Startup Folder",0

Setting:
 .db "usgdset",0

Control:
 .db "usgdctrl",0

Explore:
 .db "explore",0

Folder:
 .db 0

.end
