#include "usgard.h"
#include "lib/usgdlib.h"

cBitOfs   = $80DF      ; WORD
cXY	  = $80E1      ; WORD
cB	  = $80E3      ; 24 BYTE
cRot	  = $80FB      ; BYTE
newXY	  = $80FC      ; WORD
newRot	  = $80FE      ; BYTE
counter   = $80FF      ; BYTE
linesflag = $8100      ; BYTE
score	  = $8101      ; WORD
flags	  = $8103      ; BYTE  (0 - Quit, 1 - Update)
lines	  = $8104      ; BYTE
level	  = $8105      ; BYTE
high	  = $8106      ; BYTE
cNBitOfs  = $8107      ; WORD
stlevel   = $8109      ; BYTE
sthigh	  = $810A      ; BYTE
board	  = $810B      ; 40 BYTE
tmppage   = $8133      ; WORD

.org 0

Title:
 .db "ZTetris 3.0 Lite     ",0
 .db USGDLIB,0

 ld hl,$8C40
 set 0,(hl)
 ld hl,($8BE5)
 dec hl
 dec hl
 ld a,h
 sub 4
 ld h,a
 ld (tmppage),hl
 ld de,($8BE1)
 sbc hl,de
 ret c

 ld hl,&Resume
 ld a,(hl)
 or a
 jr z,Restart
 ld (hl),0
 inc hl
 ld de,$80DF
 ld bc,84
 ldir
 ld hl,(cBitOfs)
 ld de,(PROGRAM_ADDR)
 add hl,de
 ld (cBitOfs),hl
 ld hl,(cNBitOfs)
 ld de,(PROGRAM_ADDR)
 add hl,de
 ld (cNBitOfs),hl
 call &ShowLayout
 call &ShowInfo
 call &ShowWell
 call &ShowCurB
 ld de,$FC05
 ld hl,cB+16
 call &ShowB
 jp &MainLoop

Restart:
 ld hl,0
 ld (stlevel),hl
LevelChoose:
 call &ShowFrame
 ld hl,(stlevel)
 ld (level),hl
 xor a
NewDigit:
 call &PutDigit
 inc a
 cp 10
 jr nz,NewDigit
 ld hl,&HighTxt
 ld de,$0E02
 ld ($800C),de
 call D_ZT_STR
 ld hl,&Hiscore
 ld a,$24
 ld b,3
NewPos:
 ld e,$18
 ld d,a
 add a,6
 push af
 ld ($8333),de
 push hl
 call D_ZM_STR
 pop hl
 ld de,14
 add hl,de
 ld a,$52
 ld ($8333),a
 push hl
 call LD_HL_MHL
 call DM_HL_DECI
 pop hl
 inc hl
 inc hl
 pop af
 djnz NewPos
WaitKey:
 ld a,(level)
 set 3,(iy+5)
 call &PutDigit
 res 3,(iy+5)
 ld a,(high)
 ld hl,$1003
 ld ($800C),hl
 add a,48
 call TX_CHARPUT
GetKey:
 call GET_KEY
 cp K_EXIT
 ret z
 cp K_ENTER
 jp z,&StartGame
 ld de,high
 cp K_F4
 jr z,DecHigh
 cp K_F5
 jr z,IncHigh
 ld de,level
 dec a
 jr z,ChangeRow
 dec a
 jr z,LevLeft
 dec a
 jr z,LevRight
 dec a
 jr nz,WaitKey

ChangeRow:
 ld a,(de)
 add a,5
ChkLevEdges:
 ld h,0
 ld l,a
 call UNPACK_HL
SetLevel:
 push af
 ld a,(de)
 call &PutDigit
 pop af
 ld (de),a
 jr WaitKey
LevLeft:
 ld a,(de)
 dec a
 cp $FF
 jr nz,SetLevel
 ld a,9
 jr SetLevel
LevRight:
 ld a,(de)
 inc a
 jr ChkLevEdges

DecHigh:
 ld a,(de)
 or a
 jr z,GetKey
 dec a
 ld (de),a
 jr WaitKey

IncHigh:
 ld a,(de)
 cp 5
 jr z,GetKey
 inc a
 ld (de),a
 jr WaitKey

PutDigit:
 push af
 ld l,2
 cp 5
 jr c,FirstRow
 inc l
 sub 5
FirstRow:
 add a,a
 add a,3
 ld h,a
 ld ($800C),hl
 pop af
 push af
 add a,48
 call TX_CHARPUT
 pop af
 ret

StartGame:
 ld hl,(level)
 ld (stlevel),hl
 call CLEARLCD
 call &RandP
 ld hl,$FFFF
 ld (board+2),hl
 inc hl
 ld (flags),hl
 ld (score),hl
 ld hl,board+4
 ld b,18
InitRow:
 ld (hl),%00000111
 inc hl
 ld (hl),%11100000
 inc hl
 djnz InitRow
 call &ShowLayout
 call &NewB
 ld a,(high)
 or a
 jr z,MainLoop
 add a,a
 call &AddLines
MainLoop:
 ld hl,&levelcnts
 ld a,(level)
 ld d,0
 ld e,a
 add hl,de
 ld a,(hl)
 ld (counter),a
DelayLoop:
 ld hl,flags
 res 1,(hl)
 call GET_KEY
 cp K_EXIT
 jp z,&CheckHiscore
 cp K_MORE
 jp z,&Pause
 cp K_SECOND
 jp z,&Rotate
 cp K_ALPHA
 jp z,&RotateBack
 cp K_DEL
 jp z,&TeacherKey
 cp K_XVAR
 jp z,&Drop
 dec a
 jr z,MoveDown
 dec a
 jr z,MoveLeft
 dec a
 jr z,MoveRight
 dec a
 jp z,&Rotate
Wait:
 ld hl,flags
 bit 0,(hl)
 jp nz,&GameOver
 bit 1,(hl)
 call nz,&Update
 halt
 halt
 halt
 halt
 ld hl,counter
 dec (hl)
 jp nz,&DelayLoop
MoveDown:
 ld hl,newXY
 dec (hl)
 call &Update
 jp z,&MainLoop
BotReached:
 ld hl,cB
 ld de,(cXY)
 ld b,4
StoreB:
 push hl
 call LD_HL_MHL
 add hl,de
 call &PutCoord
 pop hl
 inc hl
 inc hl
 djnz StoreB
 call &NewB
 jp &MainLoop

MoveRight:
 ld hl,newXY+1
 inc (hl)
 jr SetUpdateFlag

MoveLeft:
 ld hl,newXY+1
 dec (hl)
SetUpdateFlag:
 ld hl,flags
 set 1,(hl)
 jr Wait

Rotate:
 ld hl,newRot
 inc (hl)
 jr SetUpdateFlag

RotateBack:
 ld hl,newRot
 dec (hl)
 jr SetUpdateFlag

Drop:
 ld hl,newXY
 dec (hl)
 call &Update
 jr z,Drop
 jr BotReached

TeacherKey:
 ld hl,(cBitOfs)
 ld de,(PROGRAM_ADDR)
 sbc hl,de
 ld (cBitOfs),hl
 ld hl,(cNBitOfs)
 sbc hl,de
 ld (cNBitOfs),hl
 ld de,&Resume
 ld a,1
 ld (de),a
 inc de
 ld hl,$80DF
 ld bc,84
 ldir
 ld a,3
 ld ($8C40),a
 ret

Pause:
 call &ShowFrame
 ld hl,$0604
 ld ($800C),hl
 ld hl,&PauseTxt
 call D_ZT_STR
PauseWait:
 call GET_KEY
 or a
 jr z,PauseWait
 call &ShowLayout
 call &ShowInfo
 call &ShowWell
 call &ShowCurB
 ld de,$FC05
 ld hl,cB+16
 call &ShowB
 jp &Wait

AddLines:
 ld b,a
 push bc
 add a,a
 ld c,a
 ld b,0
 ld de,board+34
 ld h,d
 ld l,e
 sbc hl,bc
 ld a,32
 sub c
 ld b,0
 ld c,a
 lddr
 pop bc
 ld a,b
 push af
 ld hl,board+4
AddTrashRow:
 push bc
 ld de,$FFFF
 push hl
 ld b,5
Holes:
 push bc
 ld hl,$FFFB
 ld a,10
 call &Random2
PutGap:
 ld b,a
 inc b
RotWord:
 .db $CB,$35  ; undocumented instrucion - sll l
 rl h
 djnz RotWord
 pop bc
 ld a,d
 and h
 ld d,a
 ld a,e
 and l
 ld e,a
 djnz Holes
 pop hl
 ld (hl),e
 inc hl
 ld (hl),d
 inc hl
 pop bc
 djnz AddTrashRow
 ld hl,newXY
 pop af
 add a,(hl)
 cp $10
 jr c,TopNotReached
 ld a,$10
TopNotReached:
 ld (hl),a
 call &Update
 push af
 call &ShowWell
 call &ShowCurB
 pop af
 jp nz,&GameOver
 ret

Update:
 call &TestNewB
 jr nz,Sync
 call &EraseCurB
 ld hl,(newXY)
 ld (cXY),hl
 ld a,(newRot)
 ld (cRot),a
 ld b,0
 call &Uncrunch
 call &ShowCurB
 xor a
Sync:
 push af
 ld hl,(cXY)
 ld (newXY),hl
 ld a,(cRot)
 ld (newRot),a
 pop af
 ret

GameOver:
 call GET_KEY
 cp K_SECOND
 jr z,CheckHiscore
 cp K_EXIT
 jr z,CheckHiscore
 ld a,(iy+5)
 xor 8
 ld (iy+5),a
 ld hl,$0503
 ld ($800C),hl
 ld hl,&GameOverText
 call D_ZT_STR
 ld b,30
FlashWait:
 halt
 djnz FlashWait
 jr GameOver

CheckHiscore:
 ld hl,&Hiscore+14
 ld de,(score)
 ld b,3
CheckP:
 push hl
 call LD_HL_MHL
 call CP_HL_DE
 pop hl
 jr c,ScoreGreater
 push de
 ld de,16
 add hl,de
 pop de
 djnz CheckP
 jp &LevelChoose
ScoreGreater:
 ld a,4
 sub b
 push af
 cp 3
 jr z,MoveDone
 ld hl,&Hiscore+19
MoveAgain:
 ld d,h
 ld e,l
 ld bc,16
 add hl,bc
 ex de,hl
 ld bc,13
 ldir
 ld hl,&Hiscore+3
 dec a
 jr z,MoveAgain
MoveDone:
 pop af
 dec a
 ld h,16
 ld l,a
 call MUL_HL
 ld de,&Hiscore+3
 add hl,de
 push hl
 ld de,11
 add hl,de
 ld de,(score)
 ld (hl),e
 inc hl
 ld (hl),d
 call &ShowFrame
 ld hl,$1410
 ld ($8333),hl
 ld hl,&EnterText
 call D_ZM_STR
 push hl
 ld hl,$1B26
 ld ($8333),hl
 pop hl
 call D_ZM_STR
 ld hl,$0505
 ld ($800C),hl
 pop ix
 ld c,10
 ld a,%00010000
 LIB_CALL_(USGDLIB,INPST)
 jp &LevelChoose

ShowCurB:
 ld de,(cXY)
 ld hl,cB
ShowB:
 ld b,4
SNext:
 push hl
 call LD_HL_MHL
 add hl,de
 call &PutBlock
 pop hl
 inc hl
 inc hl
 djnz SNext
 ret

EraseCurB:
 ld de,(cXY)
 ld hl,cB
EraseB:
 ld b,4
ENext:
 push hl
 call LD_HL_MHL
 add hl,de
 call &EraseBlock
 pop hl
 inc hl
 inc hl
 djnz ENext
 ret

TestNewB:
 ld b,8
 ld a,(newRot)
 call &Uncrunch
 ld de,(newXY)
 ld hl,cB+8
 ld b,4
TNext:
 push hl
 call LD_HL_MHL
 add hl,de
 call &GetCoord
 jr nz,NotPoss
 pop hl
 inc hl
 inc hl
 djnz TNext
 xor a
 ret
NotPoss:
 pop hl
 ret

NewB:
 xor a
 ld (linesflag),a
 ld hl,board+4
 ld b,17
RepScan:
 push hl
 call LD_HL_MHL
 ld de,$FFFF
 call CP_HL_DE
 jr nz,NextRow
 pop hl
 push bc
 push de
 push hl
 ld d,h
 ld e,l
 inc hl
 inc hl
 ld c,b
 ld b,0
 sla c
 ldir
 ld hl,linesflag
 inc (hl)
 ld hl,lines
 inc (hl)
 pop hl
 pop de
 pop bc
 jr RepScan
NextRow:
 pop hl
 inc hl
 inc hl
 djnz RepScan
 ld a,(linesflag)
 or a
 jr z,NoScoring
 ld hl,&Scoring
 ld d,0
 ld e,a
 dec e
 add hl,de
 ld l,(hl)
 ld a,(level)
 inc a
 ld h,a
 call MUL_HL
 ex de,hl
 ld hl,Score
 push hl
 call LD_HL_MHL
 add hl,de
 ex de,hl
 pop hl
 ld (hl),e
 inc hl
 ld (hl),d
 call &ShowWell
NoScoring:
 ld h,0
 ld a,(lines)
 ld l,a
 call UNPACK_HL
 ld a,(level)
 cp l
 jr nc,NoNewLevel
 ld a,l
 ld (level),a
 call &PastePattern
 call &ShowPattern
NoNewLevel:
 call &ShowInfo
 call &CreateNewPiece
 xor a
 ld (cRot),a
 ld (newRot),a
 ld b,0
 call &Uncrunch
 ld hl,$0610
 ld (cXY),hl
 ld (newXY),hl
 call &TestNewB
 jr z,NotDead
 ld hl,flags
 set 0,(hl)
NotDead:
 jp &ShowCurB

ShowInfo:
 ld hl,$0E61
 ld ($8333),hl
 ld hl,(score)
 call DM_HL_DECI
 ld hl,$2261
 ld ($8333),hl
 ld a,(level)
 ld h,0
 ld l,a
 call DM_HL_DECI
 ld hl,$3461
 ld ($8333),hl
 ld a,(lines)
 ld h,0
 ld l,a
 call DM_HL_DECI
 ret

CreateNewPiece:
 ld de,$FC05
 ld hl,cB+16
 call &EraseB
RandP:
 ld hl,(cNBitOfs)
 ld (cBitOfs),hl
 ld a,7
 call &Random2
 ld hl,&BitData
 add a,a
 add a,a
 add a,a
 ld d,0
 ld e,a
 add hl,de
 ld (cNBitOfs),hl
 ld b,16
 xor a
 call &Uncrunch2
 ld de,$FC05
 ld hl,cB+16
 call &ShowB
 ret

Uncrunch:
 ld hl,(cBitOfs)
Uncrunch2:
 and %00000011
 add a,a
 ld d,0
 ld e,a
 add hl,de
 push hl
 ld hl,cB
 ld d,0
 ld e,b
 add hl,de
 ex de,hl
 pop hl
 call LD_HL_MHL
 ld b,8
URep:
 ld a,l
 and %00000011
 ld (de),a
 inc de
 rr h
 rr l
 rr h
 rr l
 djnz URep
 ret

PutCoord:
 push hl
 call &GetBoardOfs
 or (hl)
 ld (hl),a
 pop hl
 ret

GetCoord:
 push hl
 call &GetBoardOfs
 and (hl)
 pop hl
 ret

GetBoardOfs:
 push bc
 ld c,l
 sla c
 bit 3,h
 jr z,LeftPart
 inc c
LeftPart:
 ld b,h
 ld a,1
RotateAgain:
 rlca
 djnz RotateAgain
 ld hl,board
 ld b,0
 add hl,bc
 pop bc
 ret

PutBlock:
 push bc
 push de
 push hl
 call &GetBlockOfs
PutRow:
 push af
 or (hl)
 ld (hl),a
 pop af
 add hl,de
 djnz PutRow
 pop hl
 pop de
 pop bc
 ret

EraseBlock:
 push bc
 push de
 push hl
 call &GetBlockOfs
 xor $FF
EraseRow:
 push af
 and (hl)
 ld (hl),a
 pop af
 add hl,de
 djnz EraseRow
 pop hl
 pop de
 pop bc
 ret

GetBlockOfs:
 ld c,h
 ld h,0
 ld a,17
 sub l
 add a,a
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 add hl,hl
 ld a,c
 srl a
 add a,4
 ld d,0
 ld e,a
 add hl,de
 ld de,$FC00
 add hl,de
 ld b,4
 ld de,16
 ld a,$F0
 bit 0,c
 ret z
 ld a,$0F
 ret

Random2:
 push bc
 push de
 push hl
 ld b,a
 ld a,r
 add a,a
 ld hl,0
 ld d,0
 ld e,a
RMul:
 add hl,de
 djnz RMul
 ld a,h
 pop hl
 pop de
 pop bc
 ret

ShowPattern:
 ld hl,&Pattern
 ld a,(level)
 cp 16
 jr c,Below16
 ld a,15
Below16:
 add a,a
 add a,a
 add a,a
 ld d,0
 ld e,a
 add hl,de
 push hl
 pop ix
 ld de,(tmppage)
 ld b,8
SP_Row:
 push bc
 push ix
 pop hl
 ld b,8
SP_Line:
 ld a,(hl)
 inc hl
 push bc
 ld b,16
SP_Byte:
 ld (de),a
 inc de
 djnz SP_Byte
 pop bc
 djnz SP_Line
 pop bc
 djnz SP_Row
 ld ix,&Gaps
 ld b,(ix-1)
MakeGap:
 push bc
 ld h,(ix+1)
 ld l,(ix)
 ld de,(tmppage)
 add hl,de
 ld a,(ix+2)
 ld b,(ix+3)
MK_Row:
 push bc
 push hl
 ld d,a
 ld b,(ix+4)
MK_Col:
 ld c,a
 and (hl)
 ld (hl),a
 ld a,c
 rrca
 jr c,MK_SameByte
 inc hl
MK_SameByte:
 djnz MK_Col
 ld a,d
 pop hl
 pop bc
 ld de,16
 add hl,de
 djnz MK_Row
 ld de,5
 add ix,de
 pop bc
 djnz MakeGap
PastePattern:
 ld hl,$FC00
 ld de,(tmppage)
PasteIt:
 ld a,(de)
 xor (hl)
 ld (hl),a
 inc de
 inc hl
 ld a,h
 or l
 jr nz,PasteIt
 ret

ShowWell:
 ld hl,$0302
SWNewRow:
 ld b,10
RepPut:
 call &GetCoord
 push af
 call z,&EraseBlock
 pop af
 call nz,&PutBlock
 inc h
 djnz RepPut
 ld h,$03
 inc l
 ld a,l
 cp $12
 jr nz,SWNewRow
 ret

ShowFrame:
 call CLEARLCD
 ld hl,0
 ld ($800C),hl
 set 3,(iy+5)
 ld hl,(PROGRAM_ADDR)
 call D_ZT_STR
 res 3,(iy+5)
 ld hl,$3A02
 ld ($8333),hl
 ld hl,&Coder
 call D_ZM_STR
 ret

ShowLayout:
 call &ShowFrame
 call CLEARLCD
 ld bc,$0761
 ld ($8333),bc
 ld hl,&InfoText
 call D_ZM_STR
 ld bc,$1B61
 ld ($8333),bc
 call D_ZM_STR
 ld bc,$2D63
 ld ($8333),bc
 call D_ZM_STR
 ld hl,&ZTet
 ld de,$FC60
 ld b,9
GFXNewRow:
 push bc
 ld bc,5
 ldir
 ld bc,11
 ex de,hl
 add hl,bc
 ex de,hl
 pop bc
 djnz GFXNewRow
 ld de,16
 ld b,64
 ld ix,$FC00
DWNextRow:
 ld (ix+5),$10
 ld (ix+10),$08
 add ix,de
 djnz DWNextRow
 ld hl,$1406
 ld ($8333),hl
 ld hl,&Coder
 ld b,8
 call D_LM_STR
 push hl
 ld hl,$1A07
 ld ($8333),hl
 pop hl
 ld b,8
 call D_LM_STR
 call &ShowPattern
 ret

;
;	  	           	
;     	         	  	  
;

BitData:
 .dw %0001010110011000,%0110010100000100
 .dw %0010000101011001,%0110101001010100
 .dw %0001010110010000,%0010011001010100
 .dw %0001010110011010,%0110010101001000
 .dw %0101100101001000,%0101100101001000
 .dw %0101100101001000,%0101100101001000
 .dw %0001010110010100,%0001011001010100
 .dw %0001011001011001,%0110010101001001
 .dw %0000010101001001,%0010000101010100
 .dw %0000010101001001,%0010000101010100
 .dw %0001010101001000,%0001000001100101
 .dw %0001010101001000,%0001000001100101
 .dw %0001010110011101,%0111011001010100
 .dw %0001010110011101,%0111011001010100

Pattern:
 .db $AA,$55,$AA,$55,$AA,$55,$AA,$55
 .db $88,$FF,$22,$FF,$88,$FF,$22,$FF
 .db $FF,$99,$99,$FF,$FF,$99,$99,$FF
 .db $50,$D7,$14,$F7,$00,$F7,$14,$D7
 .db $EA,$AA,$AE,$00,$57,$55,$75,$00
 .db $FE,$AA,$AA,$AA,$28,$AA,$FE,$00
 .db $55,$55,$AA,$AA,$55,$55,$AA,$AA
 .db $80,$FE,$02,$FB,$08,$EF,$20,$BF
 .db $EE,$EE,$EE,$00,$77,$77,$77,$00
 .db $66,$CC,$99,$33,$66,$CC,$99,$33
 .db $CC,$33,$CC,$33,$CC,$33,$CC,$33
 .db $FE,$82,$BA,$AA,$BA,$82,$FE,$00
 .db $CC,$CC,$33,$33,$CC,$CC,$33,$33
 .db $FF,$AA,$FF,$AA,$FF,$AA,$FF,$AA
 .db $7C,$FE,$7C,$00,$7C,$FE,$7C,$00
 .db $FF,$EF,$47,$12,$B8,$FD,$FF,$FF

 .db 6
Gaps:
 .dw $005 \ .db $EF,64,42
 .dw $07B \ .db $FE,14,23
 .dw $1BB \ .db $FE,14,23
 .dw $2DB \ .db $FE,14,23
 .dw $321 \ .db $FD,12,20
 .dw $040 \ .db $7F,30,43

Scoring:
 .db 4,10,30,120

InfoText:
 .db "Score",0
 .db "Level",0
 .db "Lines",0

LevelCnts:
 .db 40,36,32,28,25,22,19,17,15,13,11,10,9,8,7,6,5,4,3,2,1

Resume:
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

Hiscore:
 .db "1. ----------",0,0,0
 .db "2. ----------",0,0,0
 .db "3. ----------",0,0,0

Coder:
 .db "by Jimmy Mardell  "
 .db "<mja@algonet.se>",0

GameOverText:
 .db " Game Over ",0

PauseTxt:
 .db "* PAUSE *",0

EnterText:
 .db "You entered the hiscore table!",0
 .db "Enter your name:",0

HighTxt:
 .db "High",0

ZTet:
 .db %00111111,%11000000,%00000000,%00000000,%00000000
 .db %00111111,%11000000,%00000000,%00000000,%00000000
 .db %00100001,%10000000,%00000000,%00000000,%00000000
 .db %00100011,%00000000,%00000000,%00000000,%00000000
 .db %00000110,%00011101,%10111011,%00101100,%11000010
 .db %00001100,%01010101,%00101010,%10101000,%00100101
 .db %00011000,%01000101,%10001011,%00101110,%01000101
 .db %00111111,%11000101,%00001010,%10100010,%00100101
 .db %00111111,%11000101,%11001010,%10101110,%11001010

.end
